=== tests/restful_client_v2/requirements.txt ===
--extra-index-url https://test.pypi.org/simple/
requests>=2.32.4
urllib3>=2.5.0
pytest==7.2.0
pyyaml==6.0
numpy==1.24.3
allure-pytest>=2.8.18
Faker==19.2.0
pymilvus
scikit-learn>=1.5.2
pytest-xdist==2.5.0
minio==7.2.0
tenacity==8.1.0
# for bf16 datatype
ml-dtypes==0.2.0
loguru==0.7.3
bm25s==0.2.13
jieba==0.42.1
pyarrow==21.0.0
# for geometry data type
shapely>=2.0.0
