=== tests/python_client/chaos/requirements.txt ===

# for test result analyzer
prettytable==3.8.0
pyarrow==14.0.1
