=== tests/python_client/data_verify/requirements.txt ===
pymilvus>=2.5.11
pymilvus-pg==0.1.3
