=== tests/python_client/deploy/requirements.txt ===
--extra-index-url https://test.pypi.org/simple/
docker==5.0.0
grpcio==1.53.2
grpcio-tools==1.37.1
pymilvus==2.0.0rc8

# for test result anaylszer
prettytable==3.8.0
pyarrow==14.0.1
fastparquet==2023.7.0
