=== build/deb/debian/control ===
Source: milvus
Section: devel
Priority: optional
Maintainer: Yunmei Li <yunmei.li@zilliz.com>
Build-Depends: debhelper (>= 10), gcc (>= 7.5), g++ (>= 7.5) 
Standards-Version: 4.1.2
Homepage: https://github.com/milvus-io/milvus

Package: milvus
Architecture: any-amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, tzdata
Description: An open-source vector dstabase for unstructured data.
  Milvus was created in 2019 with a singular goal: store, index, and manage massive embedding vectors generated by deep neural networks and other machine learning (ML) models.
